/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import com.rjconsultores.ventaboletos.entidad.DiagramaAutobus;
import com.rjconsultores.ventaboletos.entidad.RolOperativo;
import com.rjconsultores.ventaboletos.service.DiagramaAutobusService;
import com.rjconsultores.ventaboletos.service.RolOperativoService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderRolOperativo;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Shiro
 */
@Controller("busquedaRolOperativoController")
@Scope("prototype")
public class BusquedaRolOperativoController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<RolOperativo> plwRolOperativo;
    @Autowired
    private RolOperativoService operativoService;
    @Autowired
    private DiagramaAutobusService autobusService;
    private MyListbox rolOperativoList;
    private List<RolOperativo> rolList;
    private List<DiagramaAutobus> diagramaList;
    private Paging pagingRolOperativo;
    private Textbox txtDesRol;
    private Combobox cmbDiagramaBus;

    public DiagramaAutobusService getAutobusService() {
        return autobusService;
    }

    public void setAutobusService(DiagramaAutobusService autobusService) {
        this.autobusService = autobusService;
    }

    public List<DiagramaAutobus> getDiagramaList() {
        return diagramaList;
    }

    public void setDiagramaList(List<DiagramaAutobus> diagramaList) {
        this.diagramaList = diagramaList;
    }

    public RolOperativoService getOperativoService() {
        return operativoService;
    }

    public void setOperativoService(RolOperativoService operativoService) {
        this.operativoService = operativoService;
    }

    public List<RolOperativo> getRolList() {
        return rolList;
    }

    public void setRolList(List<RolOperativo> rolList) {
        this.rolList = rolList;
    }

    public Combobox getCmbDiagramaBus() {
        return cmbDiagramaBus;
    }

    public void setCmbDiagramaBus(Combobox cmbDiagramaBus) {
        this.cmbDiagramaBus = cmbDiagramaBus;
    }

    public Textbox getTxtDesRol() {
        return txtDesRol;
    }

    public void setTxtDesRol(Textbox txtDesRol) {
        this.txtDesRol = txtDesRol;
    }

    public Paging getPagingRolOperativo() {
        return pagingRolOperativo;
    }

    public void setPagingRolOperativo(Paging pagingRolOperativo) {
        this.pagingRolOperativo = pagingRolOperativo;
    }

    public PagedListWrapper<RolOperativo> getPlwRolOperativo() {
        return plwRolOperativo;
    }

    public void setPlwRolOperativo(PagedListWrapper<RolOperativo> plwRolOperativo) {
        this.plwRolOperativo = plwRolOperativo;
    }

    public MyListbox getRolOperativoList() {
        return rolOperativoList;
    }

    public void setRolOperativoList(MyListbox rolOperativoList) {
        this.rolOperativoList = rolOperativoList;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        diagramaList = autobusService.obtenerTodos();
        super.doAfterCompose(comp);

        rolOperativoList.setItemRenderer(new RenderRolOperativo());
        rolOperativoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                RolOperativo rol = (RolOperativo) rolOperativoList.getSelected();
                verRolOperativo(rol);
            }
        });

        rolList = new ArrayList<RolOperativo>();

        refreshLista();
    }

    private void verRolOperativo(RolOperativo r) {
        if (r == null) {
            return;
        }

        Map args = new HashMap();
        args.put("rolOperativo", r);
        args.put("rolOperativoList", rolOperativoList);

        openWindow("/gui/esquema_operacional/editarRolOperativo.zul",
                Labels.getLabel("editarRolOperativoController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<RolOperativo> RolBusqueda =
                new HibernateSearchObject<RolOperativo>(RolOperativo.class, pagingRolOperativo.getPageSize());
        RolBusqueda.addFilterEqual("activo", Boolean.TRUE);

        RolBusqueda.addSortAsc("descroloperativo",true);

        plwRolOperativo.init(RolBusqueda, rolOperativoList, pagingRolOperativo);
    }

    public void onClick$btnPesquisa(Event ev) {


        DiagramaAutobus diagrama = (DiagramaAutobus) (cmbDiagramaBus.getSelectedItem() != null ? cmbDiagramaBus.getSelectedItem().getValue() : null);
        rolList.clear();
        rolList.addAll(operativoService.pesquisar(diagrama, txtDesRol.getValue()));
        rolOperativoList.setData(rolList);

    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verRolOperativo(new RolOperativo());
    }
}
